## mysql-workbench 6.3.8+dfsg

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
# 2.8 needed because of ExternalProject

project(WORKBENCH)

# Retrieve current Workbench version variables
execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tools/get_wb_version.sh major
                OUTPUT_VARIABLE WB_MAJOR_VERSION)
execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tools/get_wb_version.sh minor
                OUTPUT_VARIABLE WB_MINOR_VERSION)
execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tools/get_wb_version.sh revision
                OUTPUT_VARIABLE WB_RELEASE_VERSION)
execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tools/get_wb_version.sh full_version
                OUTPUT_VARIABLE WB_VERSION)

string(STRIP ${WB_MAJOR_VERSION} WB_MAJOR_VERSION)
string(STRIP ${WB_MINOR_VERSION} WB_MINOR_VERSION)
string(STRIP ${WB_RELEASE_VERSION} WB_RELEASE_VERSION)
string(STRIP ${WB_VERSION} WB_VERSION)


#  About MySQL and CMake
#  http://dev.mysql.com/doc/internals/en/autotools-to-cmake.html
#  http://www.lenzg.net/archives/291-Building-MySQL-Server-with-CMake-on-LinuxUnix.html

#-----------------------------------------------------------------------
# Find packages and other useful checks
#-----------------------------------------------------------------------

# Look for our custom modules in cmake/Modules:
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/build/cmake/Modules/")

if(ENABLE_COTIRE AND CMAKE_VERSION VERSION_GREATER "2.8.11")
  include(cotire)
  set_property(DIRECTORY PROPERTY COTIRE_UNITY_LINK_LIBRARIES_INIT "COPY_UNITY")
endif()
find_package(PkgConfig REQUIRED)

find_package(X11)

find_package(GTK2 2.20 REQUIRED gtk gtkmm)
pkg_check_modules(GTHREAD REQUIRED gthread-2.0)
pkg_check_modules(GMODULE REQUIRED gmodule-2.0)
set(GTK2_INCLUDE_DIRS ${GTK2_INCLUDE_DIRS} ${GTHREAD_INCLUDE_DIRS} ${GMODULE_INCLUDE_DIRS})
list(REMOVE_DUPLICATES GTK2_INCLUDE_DIRS)
set(GTK2_LIBRARIES ${GTK2_LIBRARIES} ${GTHREAD_LIBRARIES} ${GMODULE_LIBRARIES})
list(REMOVE_DUPLICATES GTK2_LIBRARIES)

pkg_check_modules(GLIB REQUIRED glib-2.0)

if (USE_BUNDLED_MYSQLDUMP)
  set(USE_BUNDLED_MYSQLDUMP -DHAVE_BUNDLED_MYSQLDUMP=1)
endif ()


find_package(SWIG REQUIRED)
include(${SWIG_USE_FILE})

# All known publicly available versions of Antlr3C are buggy

if (SKIP_BUNDLED_ANTLR)
  find_package(Antlr3C)
endif ()
if (ANTLR3C_FOUND)
  set(ANTLR3C_REQUIRED_VERSION "3.4")
  if (${ANTLR3C_VERSION} VERSION_LESS ${ANTLR3C_REQUIRED_VERSION})
    message("Required antlr3c version ${ANTLR3C_REQUIRED_VERSION} but ${ANTLR3C_VERSION} found, using bundled version")
    unset(ANTLR3C_FOUND)
  endif ()
endif ()

# In Ubuntu 13.04, the built-in check for python fails.. so we have to resort to the check with pkg-config (which doesn't work in many distros)
find_package(PythonLibs 2.6)
if (NOT PYTHONLIBS_FOUND)
    pkg_check_modules(PYTHON REQUIRED python)
endif ()


# We need to be able to detect python module versions and packages hence this function

FIND_PROGRAM(PYTHON_EXEC "python2")
include(FindPackageHandleStandardArgs)
function(find_python_module module minver)
        string(TOUPPER ${module} module_upper)
        if(NOT PY_${module_upper})
                if(ARGC GREATER 2 AND ARGV2 STREQUAL "REQUIRED")
                        set(PY_${module}_FIND_REQUIRED TRUE)
                endif()
                # A module's location is usually a directory, but for binary modules 
                # it's a .so file. 
                execute_process(COMMAND "${PYTHON_EXEC}" "-c" 
                        "import re, ${module}; print ${module}.__version__ if ${module}.__version__ >= '${minver}' else exit(1)" 
                        RESULT_VARIABLE _${module}_status 
                        OUTPUT_VARIABLE _${module}_location 
                        ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
                if(NOT _${module}_status)
                        set(PY_${module_upper} ${_${module}_location} CACHE STRING 
                                "Location of Python module ${module}")
                endif(NOT _${module}_status)
        endif(NOT PY_${module_upper})
        find_package_handle_standard_args(PY_${module} DEFAULT_MSG PY_${module_upper})
endfunction(find_python_module)

find_python_module(paramiko 1.15.1 QUIET)
if(NOT PY_PARAMIKO)
  message(WARNING "Paramiko wasn't found, you can still build Workbench, but may not work properly.")
endif()
find_package(MySQL 5.6.0 REQUIRED)
if (UNIX)
	set(MYSQL_DEFINITIONS "-DBIG_JOINS=1"  "-fno-strict-aliasing")
endif()
set(PRECOMPILED_HEADERS_EXCLUDE_PATHS "/usr/include/gdal;/usr/include/arpa;${CMAKE_SOURCE_DIR};${PROJECT_SOURCE_DIR}/ext/antlr-runtime;${PROJECT_BINARY_DIR};${MySQL_INCLUDE_DIRS}")



find_package(LibXml2 REQUIRED)

find_package(OpenGL REQUIRED)


find_package(CTemplate 2.2 REQUIRED)
find_package(MySQLCppConn REQUIRED)
find_package(VSqlite REQUIRED)
find_package(TinyXML REQUIRED)
find_package(GDAL REQUIRED)

if (MYSQLCPPCONN_VERSION_1_1_4)
  add_definitions(-DMYSQLCPPCONN_VERSION_1_1_4)
endif ()

if (MYSQLCPPCONN_VERSION_1_1_6_OR_HIGHER)
  add_definitions(-DMYSQLCPPCONN_VERSION_1_1_6_OR_HIGHER)
endif (MYSQLCPPCONN_VERSION_1_1_6_OR_HIGHER)

if (UNIX)
  option(USE_UNIXODBC "Use unixODBC instead of iODBC" OFF)
  find_package(IODBC)
  find_package(UNIXODBC)

  if (USE_UNIXODBC)
    if (UNIXODBC-NOTFOUND)
      message(FATAL_ERROR "You've selected Unixodbc, but it cannot be found, CMake will exit.")
    else()
		  set(ODBC_LIBRARIES ${UNIXODBC_LIBRARIES})
  		set(ODBC_INCLUDE_DIRS ${UNIXODBC_INCLUDE_DIRS})
	  	set(ODBC_DEFINITIONS ${UNIXODBC_DEFINITIONS})
    endif()
  else()
    if (IODBC_FOUND)
      message("Found iodbc, using it as ODBC library.")
      set(ODBC_LIBRARIES ${IODBC_LIBRARIES})
      set(ODBC_INCLUDE_DIRS ${IODBC_INCLUDE_DIRS})
      set(ODBC_DEFINITIONS ${IODBC_DEFINITIONS})
    elseif (UNIXODBC_FOUND)
      message("Found unixodbc, using it as ODBC library.")
      set(ODBC_LIBRARIES ${UNIXODBC_LIBRARIES})
      set(ODBC_INCLUDE_DIRS ${UNIXODBC_INCLUDE_DIRS})
      set(ODBC_DEFINITIONS ${UNIXODBC_DEFINITIONS})
    else()
      message(FATAL_ERROR "Workbench required iodbc or Unixodbc, none was found, CMake will exit.")
    endif()
  endif(USE_UNIXODBC)

endif(UNIX)


pkg_check_modules(PCRE REQUIRED libpcre libpcrecpp)
pkg_check_modules(CAIRO REQUIRED cairo>=1.5.12)
pkg_check_modules(UUID REQUIRED uuid)
pkg_check_modules(LIBZIP REQUIRED libzip)
if (UNIX)
	pkg_check_modules(GNOME_KEYRING gnome-keyring-1)
	if (GNOME_KEYRING_FOUND)
		set(KEYRING_DEFINITION     "HAVE_GNOME_KEYRING")
	else()
		pkg_check_modules(GNOME_KEYRING gnome-keyring)
		if (GNOME_KEYRING_FOUND)
			set(KEYRING_DEFINITION     "HAVE_OLD_GNOME_KEYRING")
		endif()
	endif()
endif()

if (UNIX)
  include (CheckIncludeFiles)
  CHECK_INCLUDE_FILES ("sys/prctl.h" HAVE_PRCTL)
  if (HAVE_PRCTL)
    add_definitions(-DHAVE_PRCTL_H)
  endif()
endif()

include (CheckFunctionExists)
check_function_exists (strtol HAVE_STRTOL)
check_function_exists (strtoll HAVE_STRTOLL)
check_function_exists (strtold HAVE_STRTOLD)
check_function_exists (strtoull HAVE_STRTOULL)
check_function_exists (strtoimax HAVE_STRTOIMAX)
check_function_exists (strtoumax HAVE_STRTOUMAX)

if (UNIX)
	if (NOT LIB_INSTALL_DIR)
		set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib")
	endif()
	if (NOT SHARE_INSTALL_PREFIX)
		set(SHARE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/share")
	endif()
	if (NOT ETC_INSTALL_DIR)
		set(ETC_INSTALL_DIR "/etc")
	endif()
	if (NOT REAL_EXECUTABLE_DIR)
		set(REAL_EXECUTABLE_DIR "${CMAKE_INSTALL_PREFIX}/bin")
	endif()

	set(WB_INSTALL_DIR              "${CMAKE_INSTALL_PREFIX}")
	set(WB_INSTALL_DIR_EXECUTABLE   "${REAL_EXECUTABLE_DIR}")
	set(WB_INSTALL_BIN_DIR          "${CMAKE_INSTALL_PREFIX}/bin")
	set(WB_INSTALL_LIB_DIR          "${LIB_INSTALL_DIR}/mysql-workbench")
	set(WB_PYTHON_MODULES_DIR       "${WB_INSTALL_LIB_DIR}/modules")
	set(WB_INSTALL_SHARED_DIR       "${SHARE_INSTALL_PREFIX}")
	set(WB_INSTALL_ETC_DIR          "${ETC_INSTALL_DIR}")
	set(WB_PACKAGE_SHARED_DIR       "${SHARE_INSTALL_PREFIX}/mysql-workbench")
	set(WB_PACKAGE_PLUGINS_DIR      "${LIB_INSTALL_DIR}/mysql-workbench/plugins")
	set(WB_PYTHON_MODULES_DATA_DIR  "${SHARE_INSTALL_PREFIX}/mysql-workbench/modules/data")
	set(WB_INSTALL_DOC_DIR          "${SHARE_INSTALL_PREFIX}/doc/mysql-workbench")
endif()

include(ExternalProject)

if (NOT ANTLR3C_FOUND)
  message("Using bundled Antlr C runtime")
  #  Use for Antlr3 the one we have in /ext:
  set(ANTLR3C_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/ext/antlr-runtime ${PROJECT_SOURCE_DIR}/ext/antlr-runtime/include)
  set(ANTLR3C_LIBRARIES "-L${PROJECT_BINARY_DIR}/antlr-wb -lantlr3c_wb")

  ExternalProject_Add(antlr-wb
    SOURCE_DIR ${PROJECT_SOURCE_DIR}/ext/antlr-runtime
    CONFIGURE_COMMAND autoreconf -i -s && ${PROJECT_SOURCE_DIR}/ext/antlr-runtime/configure
        --prefix=${PROJECT_BINARY_DIR}/antlr-wb
        --libdir=${PROJECT_BINARY_DIR}/antlr-wb
	--disable-abiflags
    BUILD_COMMAND make
    BUILD_IN_SOURCE 2
    INSTALL_COMMAND make install
  )

  link_directories(${PROJECT_BINARY_DIR}/antlr-wb)
endif ()

# Uncomment these lines if at any time you want to force the configure and/or build
# of antlr-wb:
#ExternalProject_Add_Step(antlr-wb forceconfigure
#    COMMAND ${CMAKE_COMMAND} -E echo "Force configure of antlr-wb"
#    DEPENDEES update
#    DEPENDERS configure
#    ALWAYS 1
#)
#ExternalProject_Add_Step(antlr-wb forcebuild
#    COMMAND ${CMAKE_COMMAND} -E echo "Force build of antlr-wb"
#    DEPENDEES configure
#    DEPENDERS build
#    ALWAYS 1
#)


#include(CheckCXXCompilerFlag)
#check_cxx_compiler_flag(-Wall  HAS_ALL_WARNS)
#if (HAS_ALL_WARNS)
#	add_definitions(-Wall)
#endif()
#check_cxx_compiler_flag(-Wsign-compare  HAS_SIGN_COMPARE)
#if (HAS_SIGN_COMPARE)
#	add_definitions(-Wsign-compare)
#endif()
add_definitions(-D__STDC_FORMAT_MACROS)

set(BUILD_SHARED_LIBS ON)  # By default all libs will be built as shared libs
SET(GCOV OFF CACHE BOOL "Add gcov flags")

# Add some common compiler flags. TODO: Shouldn't this be done checking if whatever compiler
# we use supports each flag to allow for non-gcc compilers in Linux (as above)?
if (CMAKE_COMPILER_IS_GNUCXX)
	set(MY_CXXFLAGS "-Wall -Wextra -Wno-unused-parameter -Wno-deprecated -DTIXML_USE_STL=1")

    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Werror -ggdb3 ${MY_CXXFLAGS}")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${MY_CXXFLAGS}") 
endif()

if(GCOV)
    set(MY_CXXFLAGS "${MY_CXXFLAGS} -fprofile-arcs -ftest-coverage") 
endif()



#-----------------------------------------------------------------------
# Define some useful variables and options
#-----------------------------------------------------------------------

#set(NCORES 3)  # Use this number of cores when compiling
#if(CMAKE_COMPILER_IS_GNUCXX)
#	set(CMAKE_CXX_FLAGS "${CMAKE_CKK_FLAGS} -j${NCORES}")
#	message(STATUS "CMAKE_CXX_FLAGS = ${CMAKE_CXX_FLAGS}")
#	set(CMAKE_EXE_LINKER_FLAGS_DEBUG "-s")  ## Strip binary
#endif()


set(GRT_LIBRARIES ${PYTHON_LIBRARIES} ${LIBXML2_LIBRARIES})
set(GRT_INCLUDE_DIRS ${PYTHON_INCLUDE_DIRS} ${LIBXML2_INCLUDE_DIR})

configure_file(${PROJECT_SOURCE_DIR}/mysql-workbench.desktop.in mysql-workbench.desktop)

# FIXME: Should this go here? ---v
include_directories(${PROJECT_SOURCE_DIR}/plugins/migration/copytable ${PROJECT_SOURCE_DIR}/library/base)
include_directories(${GTK2_INCLUDE_DIRS})

add_subdirectory(tools)
add_subdirectory(backend)
add_subdirectory(ext)
add_subdirectory(frontend)
add_subdirectory(images)
add_subdirectory(library)
add_subdirectory(modules)
add_subdirectory(plugins)
add_subdirectory(res)
if (IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/internal)
  add_subdirectory(internal)
endif()

install(FILES ${CMAKE_BINARY_DIR}/mysql-workbench.desktop DESTINATION ${WB_INSTALL_SHARED_DIR}/applications)

if (EXISTS ${PROJECT_SOURCE_DIR}/COPYING)
    install(FILES README COPYING DESTINATION ${WB_INSTALL_DOC_DIR})

=== frontend/CMakeLists.txt ===
add_definitions(${USE_BUNDLED_MYSQLDUMP})

if (UNIX)
	add_subdirectory(linux)
elseif(WIN32)
	add_subdirectory(windows)
elseif(APPLE)
	add_subdirectory(mac)
endif()

=== library/CMakeLists.txt ===
add_subdirectory(base)
add_subdirectory(mysql.canvas)
add_subdirectory(cdbc)
add_subdirectory(forms)
add_subdirectory(grt)
add_subdirectory(mysql.parser)
add_subdirectory(python)
add_subdirectory(sshtunnel)
add_subdirectory(sql.parser)

=== backend/wbprivate/CMakeLists.txt ===
add_definitions(${USE_BUNDLED_MYSQLDUMP})

include_directories(.
    ${CAIRO_INCLUDE_DIRS}
    ${GTK2_INCLUDE_DIRS}
    ${SIGC++_INCLUDE_DIRS}
    ${LIBZIP_INCLUDE_DIRS}
    ${GRT_INCLUDE_DIRS}
    ${ANTLR3C_INCLUDE_DIRS}
    ${MYSQLCPPCONN_INCLUDE_DIRS}
    ${PCRE_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}
    ${PROJECT_SOURCE_DIR}/library/grt/src 
    ${PROJECT_SOURCE_DIR}/library/base
    ${PROJECT_SOURCE_DIR}/library/forms
    ${PROJECT_SOURCE_DIR}/library/forms/mforms
    ${PROJECT_SOURCE_DIR}/library/mysql.parser
    ${PROJECT_SOURCE_DIR}/library/mysql.canvas/src
    ${PROJECT_SOURCE_DIR}/modules
    ${PROJECT_SOURCE_DIR}/frontend/common
    ${PROJECT_SOURCE_DIR}/backend/wbpublic
    ${PROJECT_SOURCE_DIR}/generated
    ${PROJECT_SOURCE_DIR}/backend/wbprivate/workbench 
    ${PROJECT_SOURCE_DIR}/backend/wbpublic/grt 
    ${PROJECT_SOURCE_DIR}/library/cdbc/src
    ${PROJECT_SOURCE_DIR}/ext/scintilla/include
    ${VSQLITE_INCLUDE_DIRS}
    ${TINYXML_INCLUDE_DIRS}
    ${GDAL_INCLUDE_DIRS}
)

add_library(wbprivate
    model/canvas_floater.cpp
    model/mini_view.cpp
    model/relationship_canvas_floater.cpp
    model/wb_catalog_tree_view.cpp
    model/wb_component.cpp
    model/wb_component_basic.cpp
    model/wb_component_logical.cpp
    model/wb_component_physical.cpp
    model/wb_component_physical_relationship.cpp
    model/wb_context_model.cpp
    model/wb_diagram_options.cpp
    model/wb_layer_tree.cpp
    model/wb_model_diagram_form.cpp
    model/wb_overview_diagram.cpp
    model/wb_overview_physical.cpp
    model/wb_overview_physical_schema.cpp
    model/wb_overview_privileges.cpp
    model/wb_physical_model_diagram_features.cpp
    model/wb_user_datatypes.cpp
    model/wb_history_tree.cpp
    model/wb_template_list.cpp
    sqlide/db_sql_editor_history_be.cpp
    sqlide/db_sql_editor_log.cpp
    sqlide/wb_sql_editor_form.cpp
    sqlide/wb_sql_editor_buffer.cpp
    sqlide/wb_sql_editor_form_ui.cpp
    sqlide/wb_sql_editor_help.cpp
    sqlide/wb_sql_editor_tree_controller.cpp
  	sqlide/execute_routine_wizard.cpp
    sqlide/wb_sql_editor_panel.cpp
    sqlide/wb_sql_editor_result_panel.cpp
    sqlide/wb_context_sqlide.cpp
    sqlide/result_form_view.cpp
    sqlide/wb_live_schema_tree.cpp
    sqlide/wb_sql_editor_snippets.cpp
    sqlide/query_side_palette.cpp
    sqlide/spatial_data_view.cpp
    sqlide/spatial_draw_box.cpp
    workbench/metaclasses.cpp
    workbench/upgrade_helper.cpp
    workbench/wb_command_ui.cpp
    workbench/wb_context_ui.cpp
    workbench/wb_context_ui_home.cpp
    workbench/wb_context.cpp
    workbench/wb_model_file.cpp
    workbench/wb_model_file_upgrade.cpp
    workbench/wb_module.cpp
    workbench/wb_tunnel.cpp
    workbench/wb_overview.cpp
    workbench/home_screen.cpp
    workbench/home_screen_connections.cpp
    workbench/wb_tunnel.cpp
    workbench/webbrowser_view.cpp
    workbench/wb_db_schema.cpp
    workbench/about_box.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/preferences_form.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/output_view.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/new_connection_wizard.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/document_properties_form.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/user_defined_type_editor.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/grt_shell_window.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/grt_code_editor.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/grt_python_debugger.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/plugin_manager_window.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/plugin_install_window.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/select_option_dialog.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/snippet_list.cpp
)

target_link_libraries(wbprivate
    grt
    mdcanvas
    ${CAIRO_LIBRARIES}
    ${GTK2_LIBRARIES}
    ${SIGC++_LIBRARIES}
    ${LIBZIP_LIBRARIES}
    ${TINYXML_LIBRARY}
    ${PCRE_LIBRARIES}
    ${GDAL_LIBRARIES}
)

set_target_properties(wbprivate
                      PROPERTIES VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})

if(COMMAND cotire)
  set_target_properties(wbprivate PROPERTIES
    COTIRE_PREFIX_HEADER_IGNORE_PATH "${PRECOMPILED_HEADERS_EXCLUDE_PATHS}")

  cotire(wbprivate)
endif()
install(TARGETS wbprivate DESTINATION ${WB_INSTALL_LIB_DIR})

=== backend/wbpublic/CMakeLists.txt ===
include_directories(.
    ${CAIRO_INCLUDE_DIRS}
    ${GTK2_INCLUDE_DIRS}
    ${SIGC++_INCLUDE_DIRS}
    ${GRT_INCLUDE_DIRS}
    ${PCRE_INCLUDE_DIRS}
    ${MySQL_INCLUDE_DIRS}
    ${SQLITE3_INCLUDE_DIRS}
    ${CTemplate_INCLUDE_DIRS}
    ${OPENGL_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}
    ${VSQLITE_INCLUDE_DIR}
    ${MYSQLCPPCONN_INCLUDE_DIR}
    ${ANTLR3C_INCLUDE_DIRS}
    ${GDAL_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}/library
    ${PROJECT_SOURCE_DIR}/library/grt/src 
    ${PROJECT_SOURCE_DIR}/library/base
    ${PROJECT_SOURCE_DIR}/library/base/base
    ${PROJECT_SOURCE_DIR}/library/forms
    ${PROJECT_SOURCE_DIR}/library/forms/mforms
    ${PROJECT_SOURCE_DIR}/library/cdbc/src
    ${PROJECT_SOURCE_DIR}/library/mysql.parser
    ${PROJECT_SOURCE_DIR}/library/mysql.canvas/src
    ${PROJECT_SOURCE_DIR}/modules
    ${PROJECT_SOURCE_DIR}/backend/wbpublic
    ${PROJECT_SOURCE_DIR}/generated
    ${PROJECT_SOURCE_DIR}/ext/scintilla/include
)

add_library(wbpublic
    grt/refresh_ui.cpp
    grt/editor_base.cpp
    grt/parse_utils.cpp
    grt/common.cpp
    grt/spatial_handler.cpp
    grt/grt_dispatcher.cpp
    grt/grt_manager.cpp
    grt/grt_reporter.cpp
    grt/grt_message_list.cpp
    grt/grt_shell.cpp
    grt/grt_string_list_model.cpp
    grt/grt_value_inspector.cpp
    grt/icon_manager.cpp
    grt/plugin_manager.cpp
    grt/tree_model.cpp
    grt/validation_manager.cpp
    grt/grt_threaded_task.cpp
    grt/action_list.cpp
    grtdb/charset_list.cpp
    grtdb/charset_utils.cpp
    grtdb/db_helpers.cpp
    grtdb/db_object_filter.cpp
    grtdb/db_object_helpers.cpp
    grtdb/db_object_master_filter.cpp
    grtdb/dbobject_roles.cpp
    grtdb/diff_dbobjectmatch.cpp
    grtdb/editor_dbobject.cpp
    grtdb/editor_routine.cpp
    grtdb/editor_routinegroup.cpp
    grtdb/editor_schema.cpp
    grtdb/editor_table.cpp
    grtdb/editor_user.cpp
    grtdb/editor_user_role.cpp
    grtdb/editor_view.cpp
    grtdb/role_tree_model.cpp
    grtdb/sync_profile.cpp
    objimpl/GrtStoredNote.cpp
    objimpl/db/db_DatabaseObject.cpp
    objimpl/db/db_Schema.cpp
    objimpl/db/db_Table.cpp
    objimpl/db/db_ForeignKey.cpp
    objimpl/db/db_Column.cpp
    objimpl/db/db_Index.cpp
    objimpl/db/db_Trigger.cpp
    objimpl/db/db_RoutineGroup.cpp
    grtsqlparser/module_utils.cpp
    grtsqlparser/sql_facade.cpp
    grtsqlparser/sql_parser_base.cpp
    grtsqlparser/sql_inserts_loader.cpp
    grtsqlparser/sql_semantic_check.cpp
    grtsqlparser/sql_normalizer.cpp
    grtsqlparser/sql_statement_decomposer.cpp
    grtsqlparser/sql_specifics.cpp
    grtsqlparser/mysql_parser_services.cpp
    sqlide/sqlide_generics.cpp
    sqlide/sql_editor_be.cpp
    sqlide/sql_editor_be_autocomplete.cpp
    sqlide/var_grid_model_be.cpp
    sqlide/recordset_be.cpp
    sqlide/recordset_data_storage.cpp
    sqlide/recordset_cdbc_storage.cpp
    sqlide/recordset_sql_storage.cpp
    sqlide/recordset_sqlite_storage.cpp
    sqlide/recordset_table_inserts_storage.cpp
    sqlide/recordset_text_storage.cpp
    sqlide/table_inserts_loader_be.cpp
    sqlide/autocomplete_object_name_cache.cpp
    sqlide/sql_script_run_wizard.cpp
    sqlide/column_width_cache.cpp
    sqlide/grammar-parser/ANTLRv3Lexer.c
    sqlide/grammar-parser/ANTLRv3Parser.c
    wbcanvas/figure_common.cpp
    wbcanvas/badge_figure.cpp
    wbcanvas/connection_figure.cpp
    wbcanvas/table_figure.cpp
    wbcanvas/table_figure_wb.cpp
    wbcanvas/table_figure_idef1x.cpp
    wbcanvas/table_figure_simple.cpp
    wbcanvas/view_figure.cpp
    wbcanvas/layer_figure.cpp
    wbcanvas/image_figure.cpp
    wbcanvas/note_figure.cpp
    wbcanvas/routine_group_figure.cpp
    wbcanvas/base_bridge.cpp
    wbcanvas/model_model_impl.cpp
    wbcanvas/model_diagram_impl.cpp
    wbcanvas/model_figure_impl.cpp
    wbcanvas/model_layer_impl.cpp
    wbcanvas/model_object_impl.cpp
    wbcanvas/model_connection_impl.cpp
    wbcanvas/workbench_physical_viewfigure_impl.cpp
    wbcanvas/workbench_physical_connection_impl.cpp
    wbcanvas/workbench_physical_model_impl.cpp
    wbcanvas/workbench_physical_diagram_impl.cpp
    wbcanvas/workbench_physical_routinegroupfigure_impl.cpp
    wbcanvas/workbench_physical_tablefigure_impl.cpp
    wbcanvas/workbench_model_notefigure_impl.cpp
    wbcanvas/workbench_model_imagefigure_impl.cpp
    objimpl/model/model_Connection.cpp
    objimpl/model/model_Figure.cpp
    objimpl/model/model_Layer.cpp
    objimpl/model/model_Model.cpp
    objimpl/model/model_Object.cpp
    objimpl/model/model_Diagram.cpp
    objimpl/workbench.model/workbench_model_NoteFigure.cpp
    objimpl/workbench.model/workbench_model_ImageFigure.cpp
    objimpl/workbench.physical/workbench_physical_Connection.cpp
    objimpl/workbench.physical/workbench_physical_RoutineGroupFigure.cpp
    objimpl/workbench.physical/workbench_physical_TableFigure.cpp
    objimpl/workbench.physical/workbench_physical_Diagram.cpp
    objimpl/workbench.physical/workbench_physical_Model.cpp
    objimpl/workbench.physical/workbench_physical_ViewFigure.cpp
    objimpl/workbench.logical/workbench_logical_Model.cpp
    objimpl/workbench.logical/workbench_logical_Diagram.cpp
    objimpl/db.query/db_query_Resultset.cpp
    objimpl/db.query/db_query_QueryBuffer.cpp
    objimpl/db.query/db_query_Editor.cpp
    objimpl/db.query/db_query_EditableResultset.cpp
    objimpl/db.migration/db_migration_Migration.cpp
    objimpl/ui/ui_db_ConnectPanel.cpp
    objimpl/ui/ui_ObjectEditor.cpp
    objimpl/ui/ui_ObjectEditor_impl.cpp
    objimpl/wrapper/grt_PyObject.cpp
    objimpl/wrapper/mforms_ObjectReference.cpp
    objimpl/wrapper/parser_ContextReference.cpp
    grtui/grtdb_connect_panel.cpp
    grtui/grtdb_connect_dialog.cpp
    grtui/confirm_save_dialog.cpp
    grtui/binary_data_editor.cpp
    grtui/geom_draw_box.cpp
    grtui/grtdb_connection_editor.cpp
    grtui/grtdb_object_filter.cpp
    grtui/string_list_editor.cpp
    grtui/grt_wizard_form.cpp
    grtui/grt_wizard_plugin.cpp
    grtui/wizard_progress_page.cpp
    grtui/wizard_finished_page.cpp
    grtui/wizard_schema_filter_page.cpp
    grtui/wizard_object_filter_page.cpp
    grtui/wizard_view_text_page.cpp
    grtui/db_conn_be.cpp
    grtui/gui_plugin_base.cpp
    grtui/text_input_dialog.cpp
    grtui/checkbox_list_control.cpp
    grtui/file_charset_dialog.cpp
    grtui/inserts_export_form.cpp
)

#if (CMAKE_COMPILER_IS_GNUCXX)
#	set_target_properties(wbpublic PROPERTIES
#		COMPILE_FLAGS "-fpermissive"  # For things like the extra qualification in sqlide/sql_editor_be.cpp:116
#	)
#endif()

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set_source_files_properties(sqlide/grammar-parser/ANTLRv3Lexer.c
              PROPERTIES COMPILE_FLAGS "-Wno-tautological-compare")
endif()


target_link_libraries(wbpublic wbbase mdcanvas mforms cdbc grt ${VSQLITE_LIBRARIES} wbscintilla mysqlparser ${CAIRO_LIBRARIES} ${GNOME_KEYRING_LIBRARIES} ${CTemplate_LIBRARIES} ${OPENGL_LIBRARIES} ${PCRE_LIBRARIES} ${GDAL_LIBRARIES})

set_target_properties(wbpublic
                      PROPERTIES VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})
if(COMMAND cotire)
    set_target_properties(wbpublic PROPERTIES
        COTIRE_PREFIX_HEADER_IGNORE_PATH "${PRECOMPILED_HEADERS_EXCLUDE_PATHS}")

  cotire(wbpublic)
endif()

install(TARGETS wbpublic DESTINATION ${WB_INSTALL_LIB_DIR})

=== images/home/CMakeLists.txt ===
set(IMAGE_FILES 
    WB_Home.png
    WB_Home_mac.png
    wb_close.png
    wb_doc_model.png
    wb_doc_sql.png
    wb_starter_edelivery_52.png
    wb_starter_generic_52.png
    wb_starter_grt_shell_52.png
    wb_starter_mysql_bug_reporter_52.png
    wb_starter_mysql_doc_lib_52.png
    wb_starter_mysql_forums_52.png
    wb_starter_mysql_migration_52.png
    wb_starter_mysql_news_52.png
    wb_starter_mysql_utilities_52.png
    wb_starter_mysql_wb_blog_52.png
    wb_starter_mysql_wb_twitters_52.png
    wb_starter_planet_mysql_52.png
    wb_starter_support_52.png
    wb_tile_fabric.png
    wb_tile_folder.png
    wb_tile_folder_mini.png
    wb_tile_manage.png
    wb_tile_more.png
    wb_tile_mouseover.png
    wb_tile_mouseover_2.png
    wb_tile_network.png
    wb_tile_number.png
    wb_tile_open.png
    wb_tile_page-down.png
    wb_tile_page-up.png
    wb_tile_plus.png
    wb_tile_sakila.png
    wb_tile_schema.png
    wb_tile_time.png
    wb_tile_user.png
)

install(FILES ${IMAGE_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/images)

=== images/toolbar/CMakeLists.txt ===
set(IMAGE_FILES 
clear_output.png
debug_continue.png
debug_pause.png
debug_step.png
debug_step_into.png
debug_step_out.png
debug_stop.png
edit_table_templates.png
query_continue_on_error.png
query_stop_on_error.png
record_add.png
record_autosize.png
record_back.png
record_del.png
record_discard.png
record_edit.png
record_export.png
record_fetch_all.png
record_fetch_next.png
record_fetch_prev.png
record_first.png
record_import.png
record_last.png
record_next.png
record_refresh.png
record_save.png
record_sort_asc.png
record_sort_desc.png
record_sort_reset.png
record_wrap_vertical.png
snippet_add.png
snippet_clipboard.png
snippet_del.png
snippet_insert.png
snippet_use.png
tiny_align_h_left.png
tiny_align_h_left2.png
tiny_align_h_middle.png
tiny_align_h_middle2.png
tiny_align_h_right.png
tiny_align_h_right2.png
tiny_align_v_bottom.png
tiny_align_v_bottom2.png
tiny_align_v_middle.png
tiny_align_v_middle2.png
tiny_align_v_top.png
tiny_align_v_top2.png
tiny_grid.png
tiny_gridview.png
tiny_grtshell.png
tiny_hidesidebar.png
tiny_less_space.png
tiny_load.png
tiny_loadsql.png
tiny_lock.png
tiny_more_space.png
tiny_new.png
tiny_new_diagram.png
tiny_new_doc.png
tiny_new_routine.png
tiny_new_schema.png
tiny_new_script.png
tiny_new_table.png
tiny_new_view.png
tiny_open.png
tiny_redo.png
tiny_refresh.png
tiny_refresh_plugins.png
tiny_rollback.png
tiny_rollback_disabled.png
tiny_ruler.png
tiny_save.png
tiny_saveas.png
tiny_savesql.png
tiny_search.png
tiny_undo.png
wb-toolbar_automatic-help-off.png
wb-toolbar_automatic-help-on.png
wb-toolbar_manual-help.png
wb-toolbar_nav-back.png
wb-toolbar_nav-forward.png
wb_arrow.png
wb_db_routinegroup.png
wb_db_table.png
wb_db_view.png
wb_draw_ellipse.png
wb_draw_freehand.png
wb_draw_line.png
wb_draw_polygon.png
wb_draw_rect.png
wb_hand.png
wb_image.png
wb_layer.png
wb_magnifier.png
wb_note.png
wb_rel_11.png
wb_rel_11_nonid.png
wb_rel_1n.png
wb_rel_1n_nonid.png
wb_rel_1n_pick.png
wb_rel_nm.png
wb_rubber.png
wb_toolbar_pages_18x18.png
)

install(FILES ${IMAGE_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/images)

=== images/ui/CMakeLists.txt ===
set(IMAGE_FILES 
    Apply.png
    Apply_16x16.png
    Close_18x18.png
    Close_16x16.png
    Discard.png
    Discard_16x16.png
    DotBlue.png
    DotDisabled.png
    DotGrey.png
    DotRed.png
    EditorCollapsed.png
    EditorExpanded.png
    firewall-header.png
    First_16x16.png
    Last_16x16.png
    MacWizardBackground.png
    MySQL-WB-about-screen.png
    Refresh_16x16.png
    Refresh_18x18.png
    Refresh_disabled_18x18.png
    arrow_down.png
    arrow_up.png
    audit_log.png
    background.png
    background_stripes_light.png
    background_top_shadow.png
    big_switcher_no.png
    big_switcher_yes.png
    busy_sidebar.png
    busy_sidebar_mac.png
    change_alert_create.png
    change_alert_drop.png
    change_alert_thin.png
    change_backward.png
    change_forward.png
    change_ignore.png
    change_nothing.png
    check.png
    collapsing_panel_bg.png
    collapsing_panel_grid_bg.png
    collapsing_panel_grid_details.png
    collapsing_panel_grid_details2.png
    collapsing_panel_grid_large_icons.png
    collapsing_panel_grid_large_icons2.png
    collapsing_panel_grid_small_icons.png
    collapsing_panel_grid_small_icons2.png
    collapsing_panel_header_bg.png
    collapsing_panel_header_bg_flat.png
    collapsing_panel_header_shadow.png
    collapsing_panel_header_tab_add.png
    collapsing_panel_header_tab_add2.png
    collapsing_panel_header_tab_del.png
    collapsing_panel_header_tab_del2.png
    collapsing_panel_header_tab_left.png
    collapsing_panel_header_tab_left_flat.png
    collapsing_panel_header_tab_middle.png
    collapsing_panel_header_tab_middle_flat.png
    collapsing_panel_header_tab_right.png
    collapsing_panel_header_tab_right_flat.png
    collapsing_panel_header_tab_separator.png
    collapsing_panel_header_tab_separator_flat.png
    collapsing_panel_minus.png
    collapsing_panel_minus_flat.png
    collapsing_panel_plus.png
    collapsing_panel_plus_flat.png
    collapsing_panel_tab_left.png
    collapsing_panel_tab_middle.png
    collapsing_panel_tab_right.png
    dialog_input.png
    edit.png
    field_overlay_blob.png
    field_overlay_null.png
    header_bar_blue.png
    header_bar_gray.png
    header_bar_orange.png
    item_overlay_add.png
    item_overlay_delete.png
    message_confirm.png
    message_edit.png
    message_error.png
    message_warning.png
    message_wb_bug.png
    message_wb_lock.png
    message_wb_wait.png
    navigator_zoom_in.png
    navigator_zoom_out.png
    note.128x128.png
    options-horizontal-separator.png
    refresh_sidebar.png
    refresh_sidebar_mac.png
    sakila.png
    search_clear.png
    search_doc_action.png
    search_icon.png
    search_sidebar.png
    section_expanded.png
    section_unexpandable.png
    section_unexpanded.png
    separator-dots.png
    separator_vertical.png
    show_eof.png
    show_whitespace.png
    small_toolbar_bg.png
    statusbar_output.png
    statusbar_separator.png
    statusbar_shell.png
    switcher_bottom_off_win8.png
    switcher_bottom_on_win8.png
    switcher_left_off_win8.png
    switcher_left_on_win8.png
    switcher_right_off_win8.png
    switcher_right_on_win8.png
    tab.diagram.16x16.png
    tab.overview.home.16x16.png
    tab.overview.physical.16x16.png
    tab.sqlquery.16x16.png
    task_checked.png
    task_checked_mac.png
    task_disabled.png
    task_disabled_mac.png
    task_error.png
    task_error_mac.png
    task_executing.png
    task_executing_mac.png
    task_unchecked.png
    task_unchecked_mac.png
    task_warning.png
    task_warning_mac.png
    tree_collapsed.png
    tree_expanded.png
    uncheck.png
    unknown.png
    wait_panel_cancel_button.png
    wb-wizard-vista-bg.png
    wb_lock.png
    zoom_in.png
    zoom_out.png
    zoom_reset.png
    editor_breakpoint_hit.xpm
    editor_breakpoint.xpm
    editor_continue_on_error.xpm
    editor_current_pos.xpm
    editor_error.xpm
    editor_statement.xpm
    JS_Datatype_Array.png
    JS_Datatype_Bin.png
    JS_Datatype_Bool.png
    JS_Datatype_Date.png
    JS_Datatype_Null.png
    JS_Datatype_Number.png
    JS_Datatype_Object.png
    JS_Datatype_ObjectId.png
    JS_Datatype_String.png
)

if (UNIX)
    set(IMAGE_FILES ${IMAGE_FILES}
            linux/switcher_bottom_off.png
            linux/switcher_bottom_on.png
            linux/switcher_left_off.png
            linux/switcher_left_on.png
            linux/switcher_right_off.png
            linux/switcher_right_on.png
       )
elseif (APPLE)
    set(IMAGE_FILES ${IMAGE_FILES}
            switcher_bottom_off.png
            switcher_bottom_on.png
            switcher_left_off.png
            switcher_left_on.png
            switcher_right_off.png
            switcher_right_on.png
            tab_00.png
            tab_01.png
            tab_02.png
            tab_03.png
            tab_05.png
            tab_06.png
            tab_07.png
            tab_08.png
            tab_09.png
            tab_10.png
            tab_11.png
            tab_icon_db.Routine.png
            tab_icon_db.query.QueryBuffer.png
            tab_icon_db.Schema.png
            tab_icon_db.Table.png
            tab_icon_db.View.png
       )
endif ()

install(FILES ${IMAGE_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/images)

=== library/base/CMakeLists.txt ===

add_library(wbbase 
  util_functions.cpp 
  sqlstring.cpp 
  file_functions.cpp 
  file_utilities.cpp 
  threaded_timer.cpp 
  string_utilities.cpp 
  geometry.cpp 
  notifications.cpp 
  ui_form.cpp 
  config_file.cpp 
  drawing.cpp 
  log.cpp 
  threading.cpp 
  profiling.cpp)

target_link_libraries(wbbase ${CAIRO_LIBRARIES} ${GLIB_LIBRARIES} ${GTHREAD_LIBRARIES} ${PCRE_LIBRARIES} ${PYTHON_LIBRARIES})


set_target_properties(wbbase
                      PROPERTIES VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})

if(COMMAND cotire)
    set_target_properties(wbbase PROPERTIES
        COTIRE_PREFIX_HEADER_IGNORE_PATH "${PRECOMPILED_HEADERS_EXCLUDE_PATHS}")
  cotire(wbbase)
endif()
install(TARGETS wbbase DESTINATION ${WB_INSTALL_LIB_DIR})

=== library/cdbc/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/backend
    ${PROJECT_SOURCE_DIR}/generated 
    ${PROJECT_SOURCE_DIR}/library/grt/src
    ${PROJECT_SOURCE_DIR}/library/base
    ${PROJECT_SOURCE_DIR}/ext
    ${GRT_INCLUDE_DIRS}
    ${MYSQLCPPCONN_INCLUDE_DIRS}
)

#TODO: Set other compiler flags
#if(CMAKE_COMPILER_IS_GNUCXX)
#    set(CMAKE_CXX_FLAGS  ${CMAKE_CXX_FLAGS} -Wno-unknown-pragmas)
#endif ()

add_library(cdbc
    src/driver_manager.cpp
    src/sql_batch_exec.cpp
)

target_link_libraries(cdbc ${MYSQLCPPCONN_LIBRARY})

set_target_properties(cdbc
                      PROPERTIES VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})

if(COMMAND cotire)
    set_target_properties(cdbc PROPERTIES
        COTIRE_PREFIX_HEADER_IGNORE_PATH "${PRECOMPILED_HEADERS_EXCLUDE_PATHS}")

    cotire(cdbc)
endif()
install(TARGETS cdbc DESTINATION ${WB_INSTALL_LIB_DIR})

=== library/forms/CMakeLists.txt ===
add_subdirectory(swig)

set(DATA_FILES
    gtk/embedded_find.glade
)

install(FILES ${DATA_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR})

include_directories(.
    ${CAIRO_INCLUDE_DIRS}
    ${GTK2_INCLUDE_DIRS}
    ${SIGC++_INCLUDE_DIRS}
    ${GRT_INCLUDE_DIRS}
    ${GNOME_KEYRING_INCLUDE_DIRS}
    ${PCRE_INCLUDE_DIRS}
    ${TINYXML_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}
    ${VSQLITE_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}/library
    ${PROJECT_SOURCE_DIR}/library/grt/src
    ${PROJECT_SOURCE_DIR}/library/base
    ${PROJECT_SOURCE_DIR}/library/mysql.canvas/src
    ${PROJECT_SOURCE_DIR}/library/forms
    ${PROJECT_SOURCE_DIR}/library/forms/mforms
    ${PROJECT_SOURCE_DIR}/backend/wbpublic
    ${PROJECT_SOURCE_DIR}/ext/scintilla/include
if (UNIX)
    ${PROJECT_SOURCE_DIR}/frontend/linux/linux_utilities
endif()
)

add_library(mforms
    app.cpp
    appview.cpp
    base.cpp
    box.cpp
    button.cpp
    canvas.cpp
    checkbox.cpp
    code_editor.cpp
    container.cpp
    dockingpoint.cpp
    drawbox.cpp
    filechooser.cpp
    find_panel.cpp
    form.cpp
    fs_object_selector.cpp
    gtk/src/active_label.cpp
    gtk/src/lf_box.cpp
    gtk/src/lf_button.cpp
    gtk/src/lf_code_editor.cpp
    gtk/src/lf_drawbox.cpp
    gtk/src/lf_find_panel.cpp
    gtk/src/lf_form.cpp
    gtk/src/lf_hypertext.cpp
    gtk/src/lf_label.cpp
    gtk/src/lf_listbox.cpp
    gtk/src/lf_menu.cpp
    gtk/src/lf_menubar.cpp
    gtk/src/lf_mforms.cpp
    gtk/src/lf_native.cpp
    gtk/src/lf_panel.cpp
    gtk/src/lf_popover.cpp
    gtk/src/lf_popup.cpp
    gtk/src/lf_radiobutton.cpp
    gtk/src/lf_scrollpanel.cpp
    gtk/src/lf_selector.cpp
    gtk/src/lf_splitter.cpp
    gtk/src/lf_tabview.cpp
    gtk/src/lf_textbox.cpp
    gtk/src/lf_textentry.cpp
    gtk/src/lf_table.cpp
    gtk/src/lf_toolbar.cpp
    gtk/src/lf_treenodeview.cpp
    gtk/src/lf_utilities.cpp
    gtk/src/lf_view.cpp
    gtk/src/lf_wizard.cpp
    hypertext.cpp
    imagebox.cpp
    label.cpp
    listbox.cpp
    menu.cpp
    menubar.cpp
    mforms.cpp
    native.cpp
    panel.cpp
    password_cache.cpp
    popover.cpp
    popup.cpp
    progressbar.cpp
    radiobutton.cpp
    record_grid.cpp
    scrollpanel.cpp
    sectionbox.cpp
    selector.cpp
    simpleform.cpp
    splitter.cpp
    table.cpp
    tabswitcher.cpp
    tabview.cpp
    tabview_dock.cpp
    task_sidebar.cpp
    textbox.cpp
    textentry.cpp
    toolbar.cpp
    treenodeview.cpp
    utilities.cpp
    view.cpp
    webbrowser.cpp
    jsonview.cpp
    widgets.cpp
    wizard.cpp
)

if (KEYRING_DEFINITION)
	set_target_properties(mforms PROPERTIES
		COMPILE_DEFINITIONS "${KEYRING_DEFINITION}"
	)
endif()
if (CMAKE_COMPILER_IS_GNUCXX)
	set_target_properties(mforms PROPERTIES
	  COMPILE_FLAGS "-DSCI_NAMESPACE"
	)
endif()

target_link_libraries(mforms linux_utilities mdcanvasgtk mdcanvas wbscintilla ${CAIRO_LIBRARIES} ${GTK2_LIBRARIES} ${GNOME_KEYRING_LIBRARIES} ${TINYXML_LIBRARY})

set_target_properties(mforms
                      PROPERTIES VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})

if(COMMAND cotire)
    set_target_properties(mforms PROPERTIES
        COTIRE_PREFIX_HEADER_IGNORE_PATH "${PRECOMPILED_HEADERS_EXCLUDE_PATHS}")

  cotire(mforms)
endif()

install(TARGETS mforms DESTINATION ${WB_INSTALL_LIB_DIR})

=== library/mysql.parser/CMakeLists.txt ===
add_definitions(-Wno-sign-compare -Wno-type-limits -Wno-unused
-Wno-missing-field-initializers)

include_directories(.
    ${GTK2_INCLUDE_DIRS}
    ${ANTLR3C_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}/library/base
)

add_subdirectory(grammar)

add_library(mysqlparser
    MySQLLexer.c
    MySQLSimpleParser.c
    MySQLParser.c
    mysql-parser-common.cpp
    mysql-parser.cpp
    mysql-scanner.cpp
    mysql-syntax-check.cpp
)

add_dependencies(mysqlparser
    antlr-wb
    generate_parser
)

if (SKIP_BUNDLED_ANTLR)
else ()
    link_directories(${PROJECT_BINARY_DIR}/antlr-wb)
endif ()

target_link_libraries(mysqlparser ${GTK2_LIBRARIES} ${ANTLR3C_LIBRARIES})

set_target_properties(mysqlparser
                      PROPERTIES VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})
if(COMMAND cotire)
    set_target_properties(mysqlparser PROPERTIES
        COTIRE_PREFIX_HEADER_IGNORE_PATH "${PRECOMPILED_HEADERS_EXCLUDE_PATHS}")

  cotire(mysqlparser)
endif()

install(TARGETS mysqlparser DESTINATION ${WB_INSTALL_LIB_DIR})

install(DIRECTORY ${PROJECT_BINARY_DIR}/antlr-wb/ DESTINATION ${WB_INSTALL_LIB_DIR} FILES_MATCHING
    PATTERN "*.so"
    PATTERN "*.so.*"
)

set(DATA_FILES 
    MySQL.tokens
)

install(FILES ${DATA_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/data)

=== debian/changelog ===
mysql-workbench (6.3.8+dfsg-1build3) bionic; urgency=medium

  * Rebuild against new gdal-abi-2-2-3.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 17 Dec 2017 22:11:28 +0100

mysql-workbench (6.3.8+dfsg-1build2) bionic; urgency=medium

  * No-change rebuild against gdal-abi-2-2-2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 03 Nov 2017 20:26:59 +0000

mysql-workbench (6.3.8+dfsg-1build1) artful; urgency=medium

  * Rebuild against new gdal ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Jul 2017 13:04:29 +0200

mysql-workbench (6.3.8+dfsg-1) unstable; urgency=medium

  * New upstream release [October 2016].
  * Removed obsolete "gtk.patch".
  * Added new "projloc.patch".
  * debhelper/compat to version 10.
  * Recommends: mysql-client --> default-mysql-client.
  * Standards-Version: 3.9.8;
  * Do not install menu and .xpm files;
    removed "imagemagick" from Build-Depends.
  * Build-Depends += "dh-python"; invoke dh_python2 with "--no-ext-rename".
  * Build-Depends: strict libmysqlcppconn-dev versioning (Closes: #844381).

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 19 Nov 2016 08:09:03 +1100

mysql-workbench (6.3.6+dfsg-1) unstable; urgency=medium

  * New upstream release [December 2015].
    + fixed "Unhandled exception on Data Export" (Closes: #822413).
    + fixed "don't open files with same name but difference locations"
      (Closes: #804774).
  * Switch to "default-libmysqlclient-dev"
    (Closes: #840786, #841584, #843457, #843887).
  * Modernised Vcs URLs; copyright format URL to HTTPS.
  * Removed traces of -dbg package.
  * New patches:
    + gtk.patch (Closes: #839356).
    + mariadb-build.patch
    + mariadb-version.patch
    + no-MYSQL_TYPE_JSON.patch
  * Removed obsolete "gcc5.patch".

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 14 Nov 2016 01:12:33 +1100

=== debian/control ===
Source: mysql-workbench
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Uploaders: Mateusz Kijowski <mateusz.kijowski@gmail.com>
Build-Depends: debhelper (>= 10) ,dh-autoreconf ,dh-python
 ,cmake ,perl
 ,autoconf ,automake ,libtool
 ,bison ,flex ,swig
 ,doxygen
 ,gettext
# ,libantlr3c-dev
 ,libboost-dev
 ,libcairo2-dev
 ,libctemplate-dev
 ,libfreetype6-dev
 ,libgdal-dev
 ,libgl1-mesa-dev
 ,libglib2.0-dev
 ,libgnome-keyring-dev
 ,libgtkmm-2.4-dev
 ,liblua5.1-0-dev
 ,libmysqlcppconn-dev (>= 1.1.7-4~)
 ,libpng-dev
 ,default-libmysqlclient-dev
 ,libpcre3-dev
 ,libpixman-1-dev
 ,libsqlite3-dev
 ,libtinyxml-dev (>= 2.6.2)
 ,libvsqlitepp-dev
 ,libxml2-dev
 ,libzip-dev
 ,python-dev
 ,unixodbc-dev
 ,uuid-dev
 ,xdg-utils
Standards-Version: 3.9.8
Homepage: http://dev.mysql.com/workbench/
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/mysql-workbench.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/mysql-workbench.git

Package: mysql-workbench
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
 ,mysql-workbench-data (= ${source:Version})
 ,python-mysql.connector
 ,python-paramiko
 ,python-pexpect
 ,python-pyodbc (>= 2.1.8)
 ,python-pysqlite2
Recommends: ttf-bitstream-vera, mysql-utilities
           ,default-mysql-client | virtual-mysql-client
Suggests: gnome-keyring
Description: MySQL Workbench - a visual database modeling, administration and queuing tool
 MySQL Workbench is a modeling tool that allow to design
 and generate MySQL databases graphically. It also has administration
 and query development modules where you can manage MySQL server instances
 and execute SQL queries.

Package: mysql-workbench-data
Architecture: all
Depends: ${misc:Depends}
Description: MySQL Workbench -- architecture independent data
 MySQL Workbench is a modeling tool that allow to design
 and generate MySQL databases graphically. It also has administration
 and query development modules where you can manage MySQL server instances
 and execute SQL queries.
 .
 This package provides architecture independent files

#Package: mysql-workbench-docs
#Architecture: all
#Depends: ${misc:Depends}, libjs-jquery
#Recommends: yelp
#Suggests: www-browser
#Section: doc
#Description: MySQL Workbench -- Documentation for developers
# MySQL Workbench is a modeling tool that allow to design
# and generate MySQL databases graphically. It also has administration
# and query development modules where you can manage MySQL server instances
# and execute SQL queries.
# .
# This package provides documentation for developers

=== debian/watch ===
# uscan(1) configuration file.
# Use 'debian/rules get-orig-source' command to generate DFSG-repackaged archive.

version=3

opts=\
pgpsigurlmangle=s/$/.asc/,\
dversionmangle=s/\+dfsg\d*// \
http://www.mirrorservice.org/sites/ftp.mysql.com/Downloads/MySQLGUITools\
/mysql-workbench-community-([\d\.]+)(?:-nodocs)?-src\.tar\.(?:gz|bz2|xz)
